﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _140349
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            radDateTimePicker1.Format = DateTimePickerFormat.Custom;
            radDateTimePicker1.CustomFormat = "dd/MM/yyyy";

            MaskDateTimeProvider provider = (this.radDateTimePicker1.DateTimePickerElement.TextBoxElement.Provider as MaskDateTimeProvider);
            provider.TextBoxItem.KeyDown+=new KeyEventHandler(TextBoxItem_KeyDown); 
        
        }

        int day = 0;
        int month = 0;
        void TextBoxItem_KeyDown(object sender, KeyEventArgs e)
        {
           if ((e.KeyCode >= Keys.D0 && e.KeyCode <= Keys.D9) || (e.KeyCode >= Keys.NumPad0 && e.KeyCode <= Keys.NumPad9) || e.KeyCode == Keys.Decimal)
           {
                RadTextBoxItem item = sender as RadTextBoxItem;
                RadMaskedEditBoxElement element = item.Parent as RadMaskedEditBoxElement;
                MaskDateTimeProvider provider = element.Provider as MaskDateTimeProvider;
               
                switch (provider.List[provider.SelectedItemIndex].type)
                {
                    case PartTypes.Day:
                        day++;
                        break;
                    case PartTypes.Month:
                        month++;
                        break;
                }

                if (day == 2)
                {
                    provider.SelectNextEditableItem();
                    day = 0;
                }
                if (month == 2)
                {
                    provider.SelectNextEditableItem();
                    month = 0;
                }
            }
            else if (e.KeyData == Keys.Left || e.KeyData == Keys.Right || e.KeyData == Keys.Divide)
            {
                day = 0;
                month = 0;
            }
        }
    }
}
